Subject: bug#68981: [PATCH] Add support for deriving major modes in which-func

From: Damien Cassou <[email-masked]>
Date: Wed, 07 Feb 2024 20:51:31 +0100

Tags: patch

Hi,

I wanted to configure which-func to activate only for programmation
modes so I wrote:

(use-package which-func
  :init
  (progn
    (setq which-func-modes '(prog-mode)))
  :config
  (progn
    (which-function-mode)))

But this doesn't work because which-func only checks for exact major
modes, not derived ones: because emacs-lisp-mode is not in
`which-func-modes`, I won't get which-func to activate in
emacs-lisp-mode even though I want it.

I wrote the attached patch so which-func uses `derived-mode-p'. This
solves my issue.

-- 
Damien Cassou

"Success is the ability to go from one failure to another without
losing enthusiasm." --Winston Churchill
>From a0cda58b28ee0bebd38aa6d7d61546d3eeeedbc9 Mon Sep 17 00:00:00 2001
From: Damien Cassou <[email-masked]>
Date: Wed, 7 Feb 2024 20:41:44 +0100
Subject: [PATCH] Add support for deriving major modes in which-func

* lisp/progmodes/which-func.el (which-func-try-to-enable)
(which-func-ff-hook): Use `derived-mode-p' to check if the current
major mode is within `which-func-modes' or
`which-func-non-auto-modes'.
---
 lisp/progmodes/which-func.el | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/lisp/progmodes/which-func.el b/lisp/progmodes/which-func.el
index bd68672f905..631cb3b0aef 100644
--- a/lisp/progmodes/which-func.el
+++ b/lisp/progmodes/which-func.el
@@ -211,7 +211,7 @@ which-func-try-to-enable
   (when which-function-mode
     (unless (local-variable-p 'which-func-mode)
       (setq which-func-mode (or (eq which-func-modes t)
-                                (member major-mode which-func-modes)))
+                                (apply #'derived-mode-p which-func-modes)))
       (setq which-func--use-mode-line
             (member which-func-display '(mode mode-and-header)))
       (setq which-func--use-header-line
@@ -239,7 +239,7 @@ which-func-ff-hook
 
   (condition-case err
       (if (and which-func-mode
-	       (not (member major-mode which-func-non-auto-modes))
+	       (not (apply #'derived-mode-p which-func-non-auto-modes))
 	       (or (null which-func-maxout)
 		   (< buffer-saved-size which-func-maxout)
 		   (= which-func-maxout 0)))
-- 
2.43.0